'FM radio RDS SE 2019, OK

$crystal = 16000000
$regfile = "m328pdef.dat"
$hwstack = 32
$swstack = 8
$framesize = 32

Config Clockdiv = 1

Const Joystick_xy = 1         '1-2
Const Joystick_pm = 1         '1-4
Const Preset_no = 40          '1-40

$include "PT2257$SE.sub"      'include PT2257 subroutines
$include "RDA5807M$SE.sub"    'include RDA5807M subroutines

Dim Reset_flag_eram As Eram Byte
Dim Preset_eram As Eram Byte
Dim Preset_max_eram As Eram Byte
Dim Volume_eram As Eram Byte
Dim Freq_table(40) As Eram Word

Dim 10f As Word , 10f_old As Word
Dim Preset As Byte
Dim Radio_mode As Byte        '0=Preset, 1=tune , 2=save
Dim Volume As Byte            '0-24
Dim Message As String * 16
Dim Adc_value As Word , Xy_value As Byte
Dim X_value As Byte , X_value_old As Byte , X_time As Byte
Dim Y_value As Byte , Y_value_old As Byte , Y_time As Byte
Dim B_time As Byte

Button Alias Pinc.2
Config Button = Input
U_tda2822 Alias Portb.0
Config U_tda2822 = Output
U_display Alias Portb.1
Config U_display = Output

Config Lcdbus = 4
Config Lcd = 16 * 2
Config Lcdpin = Pin , _
        Db7 = Pind.7 , Db6 = Pind.6 , _
        Db5 = Pind.5 , Db4 = Pind.4 , _
        E = Pind.3 , Rs = Pind.2
Cursor Off
Cls

Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Scl = Portc.4          'SCL pin name
Config Sda = Portc.5          'SDA pin name
Config I2cdelay = 5           'I2C clock speed ~ 75 kHz
I2cinit
Waitms 10

If Button = 0 Or Reset_flag_eram <> 0 Then
  Gosub Reset_radio
End If
Gosub Disp_message

X_value_old = 9
Y_value_old = 9
Gosub Init_radio
U_tda2822 = 1

Do
  Debounce Button , 0 , Button_sub , Sub
  While Radio_mode >= 2
    Debounce Button , 0 , Save_sub , Sub
  Wend

  Gosub Read_x
  If X_value <> X_value_old Then
    Gosub X_value_changed
    X_value_old = X_value
  Else
    Gosub X_value_same
  End If

  Gosub Read_y
  If Y_value <> Y_value_old Then
    Gosub Y_value_changed
    Y_value_old = Y_value
  Else
    Gosub Y_value_same
  End If

  Rda5807m$read_info
  Rda5807m$read_rds_0a
  Gosub Disp_info
Loop

End

#if Preset_no = 0
  Const Preset_no_max = 0
#else
  #if Preset_no <= 40
    Const Preset_no_max = Preset_no - 1
  #else
    Const Preset_no_max = 39
  #endif
#endif

#if Joystick_xy = 1
#if Joystick_pm = 1
Read_x:
  Adc_value = Getadc(0)
  Gosub Read_xy
  X_value = Xy_value
Return

Read_y:
  Adc_value = Getadc(1)
  Gosub Read_xy
  Y_value = Xy_value
Return
#endif

#if Joystick_pm = 2
Read_x:
  Adc_value = Getadc(0)
  Gosub Read_xy
  X_value = 4 - Xy_value
Return

Read_y:
  Adc_value = Getadc(1)
  Gosub Read_xy
  Y_value = Xy_value
Return
#endif

#if Joystick_pm = 3
Read_x:
  Adc_value = Getadc(0)
  Gosub Read_xy
  X_value = Xy_value
Return

Read_y:
  Adc_value = Getadc(1)
  Gosub Read_xy
  Y_value = 4 - Xy_value
Return
#endif

#if Joystick_pm = 4
Read_x:
  Adc_value = Getadc(0)
  Gosub Read_xy
  X_value = 4 - Xy_value
Return

Read_y:
  Adc_value = Getadc(1)
  Gosub Read_xy
  Y_value = 4 - Xy_value
Return
#endif
#endif

#if Joystick_xy = 2
#if Joystick_pm = 1
Read_x:
  Adc_value = Getadc(1)
  Gosub Read_xy
  X_value = Xy_value
Return

Read_y:
  Adc_value = Getadc(0)
  Gosub Read_xy
  Y_value = Xy_value
Return
#endif

#if Joystick_pm = 2
Read_x:
  Adc_value = Getadc(1)
  Gosub Read_xy
  X_value = 4 - Xy_value
Return

Read_y:
  Adc_value = Getadc(0)
  Gosub Read_xy
  Y_value = Xy_value
Return
#endif

#if Joystick_pm = 3
Read_x:
  Adc_value = Getadc(1)
  Gosub Read_xy
  X_value = Xy_value
Return

Read_y:
  Adc_value = Getadc(0)
  Gosub Read_xy
  Y_value = 4 - Xy_value
Return
#endif

#if Joystick_pm = 4
Read_x:
  Adc_value = Getadc(1)
  Gosub Read_xy
  X_value = 4 - Xy_value
Return

Read_y:
  Adc_value = Getadc(0)
  Gosub Read_xy
  Y_value = 4 - Xy_value
Return
#endif
#endif

Read_xy:
  If Adc_value < 150 Then
    Xy_value = 0
  Elseif Adc_value > 873 Then
    Xy_value = 4
  Else
    Xy_value = 2
  End If
Return

Button_sub:
  X_time = 0
  Y_time = 0
  For B_time = 0 To 20
    Waitms 50
    If Button = 1 Then Exit For
  Next
  If B_time < 21 Then
    Incr Radio_mode
    If Radio_mode = 1 Then
      10f_old = 10f
    End If
    If Radio_mode >= 2 Then
      If 10f = 10f_old Then
        Radio_mode = 0
      End If
    End If
    Gosub Disp_info
  Else
    Gosub Radio_off
  End If
Return

Radio_off:
  U_tda2822 = 0
  Preset_eram = Preset
  Volume_eram = Volume
  Message = "Goodbye..."
  Gosub Disp_message
  U_display = 0
  Rda5807m$standby
  Config Clockdiv = 256
  For B_time = 0 To 19
    If Button = 1 Then B_time = 0
    Waitus 200
  Next
Radio_on:
  Config Clockdiv = 1
  Message = "Hello!!!"
  Gosub Disp_message
  B_time = 0
  Rda5807m$power_up
  Gosub Init_radio_1
  U_tda2822 = 1
Return

Save_sub:
  For B_time = 0 To 20
    Waitms 50
    If Button = 1 Then Exit For
  Next
  If B_time >= 21 Then
    Freq_table(preset) = 10f
    If Preset_max_eram < Preset_no_max Then
      If Preset_max_eram = Preset Then
        Incr Preset
        Preset_max_eram = Preset
        Decr Preset
      End If
    End If
  End If
  Gosub Init_radio_0
Return

X_value_changed:
  If X_value_old = 2 Then
    If Radio_mode = 1 Then
      Gosub Tune
    Else
      Gosub Change_preset
    End If
    X_time = 0
  End If
Return

X_value_same:
  If X_time < 5 Then
    Incr X_time
  Elseif X_value <> 2 Then
    If Radio_mode = 1 Then
      Gosub Seek
    Else
      Gosub Change_preset
    End If
    Waitms 1500
  End If
Return

Reset_radio:
  Reset_flag_eram = 0
  Preset_eram = 0
  Preset_max_eram = 0
  Volume_eram = 12
  For Preset = 0 To Preset_no_max
    Freq_table(preset) = 874
  Next
  Message = "Reset!!!"
Return

Init_radio:
  Rda5807m$set_volume 7
  Volume = Volume_eram
  Pt2257$set_volume Volume
  Preset = Preset_eram
Init_radio_0:
  Radio_mode = 0
  10f = Freq_table(preset)
Init_radio_1:
  Rda5807m$tune 10f
    Waitms 200
    Rda5807m$read_info
  Gosub Disp_info
Return

Change_preset:
  If X_value < 2 Then
    Decr Preset
    If Preset > Preset_max_eram Then Preset = Preset_max_eram
  End If
  If X_value > 2 Then
    Incr Preset
    If Preset > Preset_max_eram Then Preset = 0
  End If
  If Radio_mode = 0 Then
    10f = Freq_table(preset)
    Rda5807m$tune 10f
    Waitms 200
    Rda5807m$read_info
  End If
  Gosub Disp_info
Return

Tune:
  If X_value < 2 Then
    Decr 10f
    If 10f < 875 Then 10f = 1080
  End If
  If X_value > 2 Then
    Incr 10f
    If 10f > 1080 Then 10f = 875
  End If
  Rda5807m$tune 10f
  Waitms 200
  Rda5807m$read_info
  Gosub Disp_info
Return

Seek:
  Rda5807m$signal_level = 0
  If X_value < 2 Then
    Message = " <<seek<< "
    Gosub Disp_seek
    Rda5807m$seek_down
  End If
  If X_value > 2 Then
    Message = " >>seek>> "
    Gosub Disp_seek
    Rda5807m$seek_up
  End If
  Waitms 800
  Rda5807m$read_info
  10f = Rda5807m$channel + 870
  Gosub Disp_info
Return

Y_value_changed:
  If Y_value_old = 2 Then
    Gosub Change_volume
    Y_time = 0
  End If
Return

Y_value_same:
  If Y_time < 5 Then
    Incr Y_time
  Elseif Y_value <> 2 Then
    Gosub Change_volume
  End If
Return

Change_volume:
  If Y_value < 2 Then
    If Volume > 0 Then Decr Volume
  End If
  If Y_value > 2 Then
    If Volume < 24 Then Incr Volume
  End If
  Pt2257$set_volume Volume
  Gosub Disp_info
Return

Disp_info:
  Locate 1 , 1
  If Radio_mode = 0 Then
    Lcd "<P" ; Preset ; "> "
  Elseif Radio_mode = 1 Then
    Lcd " P" ; Preset ; Spc(2)
  Else
    Lcd "Save?"
  End If

  Locate 1 , 7
  If 10f < 875 Then
    Rda5807m$mute 1
    Message = "____"
  Else
    Rda5807m$mute 0
    Message = Str(10f)
    If 10f < 1000 Then
      Insertchar Message , 1 , " "
    End If
  End If
  If Radio_mode = 0 Then
    Insertchar Message , 1 , " "
    Insertchar Message , 6 , " "
  Else
    Insertchar Message , 1 , "<"
    Insertchar Message , 6 , ">"
  End If
  Insertchar Message , 5 , "."
  If Radio_mode = 0 And Len(rda5807m$group_0a) = 8 Then
    Lcd " " ; Rda5807m$group_0a ; " "
  Else
    Lcd Message ; "MHz"
  End If

  Locate 2 , 1
  Lcd "Vol=" ; Volume ; Spc(1)
  Locate 2 , 7
  Lcd " Sig=" ; Rda5807m$signal_level ; Spc(1)
  Locate 2 , 14
  If Rda5807m$stereo = 0 Then
    Lcd " MO"
  Else
    Lcd " ST"
  End If
Return

Disp_message:
  Cls
  U_display = 1
  Lcd "FM radio SE 2019"
  Locate 2 , 1
  Lcd Message ; Spc(16)
  Waitms 2000
  While Button = 0
  Wend
  Cls
Return

Disp_seek:
  Locate 1 , 7
  Lcd Message
  Locate 2 , 7
  Lcd Spc(10)
Return

$eeprom

Dim Reset_flag_eram_data As Eram Byte At Reset_flag_eram Overlay
Data &HFF

Dim Preset_eram_data As Eram Byte At Preset_eram Overlay
Data 0

Dim Preset_max_eram_data As Eram Byte At Preset_max_eram Overlay
Data 0

Dim Volume_eram_data As Eram Byte At Volume_eram Overlay
Data 12

Dim Freq_table_data(40) As Eram Word At Freq_table(0) Overlay
Data 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874%
Data 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874%
Data 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874%
Data 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874% , 874%

$data